use "C:\成人库数据.dta"
 ///教育流动矩阵///
 asdoc tabulate bfeduc educ if landless==1 , cell
 asdoc tabulate bfeduc educ if landless==0 , cell 
 ******生成的矩阵需结合公式计算得出流动指数******
 ///基准回归结果///
global xlist gender age age2 minority fage mage urban fparty mparty
probit up_m meduc landless land_meduc  $xlist i.region i.year , robust nolog
probit up_f feduc landless land_feduc  $xlist i.region i.year , robust nolog
probit up_fm bfeduc landless land_bfeduc  $xlist i.region i.year , robust nolog
//基准中的m均表示母亲，f表示父亲，bf表示父母中最高的，以下稳健性、异质性同理

///以下是稳健性检验///
****1.内生性检验****
gen iv_land_meduc=(iv_shidi*meduc)  //iv_shidi表示的是土地征收的工具变量
ivprobit up_m meduc $xlist  i.year i.region ( landless land_meduc =iv_shidi iv_land_meduc) ,first twostep
gen iv_land_feduc=(iv_shidi*feduc)
ivprobit up_f feduc $xlist  i.year i.region ( landless land_feduc = iv_shidi iv_land_feduc) ,first twostep
gen iv_land_bfeduc=(iv_shidi*bfeduc)
ivprobit up_fm bfeduc $xlist i.year i.region ( landless land_bfeduc = iv_shidi iv_land_bfeduc) ,first twostep
****2.相对教育代际向上流动****
probit up_fp x_feducm landless lab_feducm  $xlist i.region i.year , robust nolog
probit up_mp x_meducm landless lab_meducm  $xlist i.region i.year , robust nolog
probit up_bfp x_bfeducm landless lab_bfeducm  $xlist i.region i.year , robust nolog
****3.剔除部分样本****
probit up_m meduc land_c land_meduc_1  $xlist i.region i.year , robust nolog
probit up_f feduc land_c land_feduc_1  $xlist i.region i.year , robust nolog
probit up_fm bfeduc land_c land_bfeduc_1  $xlist i.region i.year , robust nolog
****4.替换受教育程度***
probit up_f_1 feduy landless land_feduy $xlist i.region i.year, r 
probit up_m_1 meduy landless land_meduy $xlist i.region i.year, r
probit up_bf_1 bfeduy landless land_bfeduy $xlist i.region i.year, r

///以下是异质性分析///
****1.性别，女0，男1******
global xlist age age2 minority fage mage urban fparty mparty
probit up_m meduc landless land_meduc  $xlist i.region i.year if gender==1, robust
probit up_f feduc landless land_feduc  $xlist i.region i.year if gender==1, robust
probit up_fm bfeduc landless land_bfeduc  $xlist i.region i.year if gender==1, robust
probit up_m meduc landless land_meduc  $xlist i.region i.year if gender==0, robust 
probit up_f feduc landless land_feduc  $xlist i.region i.year if gender==0, robust
probit up_fm bfeduc landless land_bfeduc  $xlist i.region i.year if gender==0, robust
******2.城乡，农村0，城镇1********
probit up_m meduc landless land_meduc  $xlist i.region i.year if urban==1, robust
probit up_f feduc landless land_feduc  $xlist i.region i.year if urban==1, robust
probit up_fm bfeduc landless land_bfeduc  $xlist i.region i.year if urban==1, robust
probit up_m meduc landless land_meduc  $xlist i.region i.year if urban==0, robust 
probit up_f feduc landless land_feduc  $xlist i.region i.year if urban==0, robust
probit up_fm bfeduc landless land_bfeduc  $xlist i.region i.year if urban==0, robust
***********3.区域,东1，中2，西3***********
probit up_m meduc landless land_meduc  $xlist  i.year if region==1, robust
probit up_f feduc landless land_feduc  $xlist  i.year if region==1, robust
probit up_fm bfeduc landless land_bfeduc  $xlist  i.year if region==1, robust
probit up_m meduc landless land_meduc  $xlist  i.year if region==2, robust
probit up_f feduc landless land_feduc  $xlist  i.year if region==2, robust
probit up_fm bfeduc landless land_bfeduc  $xlist  i.year if region==2, robust
probit up_m meduc landless land_meduc  $xlist  i.year if region==3, robust
probit up_f feduc landless land_feduc  $xlist  i.year if region==3, robust
probit up_fm bfeduc landless land_bfeduc  $xlist  i.year if region==3, robust

use "C:\少儿库数据.dta"
///机制检验///
****1.教育投入机制****
global xlist lfaminc_net familysize fage mage age expectedu
xtreg exp_edu loseland $xlist i.year i.region, fe robust   //多期did估计
gen didlength=year-first_treat
replace didlength=-6 if didlength<-6
replace didlength=8 if didlength>8
tab didlength,gen(event)
drop event3  //删除事前一期
reghdfe exp_edu event1 event2 event4 event5 event6 event7 event8 $xlist , absorb(pid year region) cluster(pid)
*画图
coefplot, levels(95) keep(event*) ///
vertical ///转置图形
coeflabels(event1="pre_3" event2="pre_2" event4="current" event5="post_1" event6="post_2" event7="post_3" event8="post_4" ) ///coeflabels为系数指定自定义标签，在这里修改横坐标
yline(0,lcolor(edkblue*0.8)) ///
ylabel(-0.06(0.02)0.06) ///
xline(3,lwidth(vthin) lpattern(dash) lcolor(teal)) ///
ylabel(,labsize(*0.75)) xlabel(,labsize(*0.75)) ///
ytitle("动态效应", size(small)) ///y轴标题
xtitle("失地时点" , size(small)) ///x轴标题
addplot(line @b @at) ///增加点之间的连线
ciopts(lpattern(dash) recast(rcap) msize(medium)) ///CI为虚线上下封口
msymbol(circle_hollow) ///plot空心格式
scheme(s1mono)
****2.留守机制检验****
xtlogit liushou loseland lfaminc_net familysize fage mage age expectedu i.year
margins,dydx(loseland)
xtlogit liushou loseland lfaminc_net familysize fage mage age expectedu i.year , fe
margins,dydx(loseland)
xtlogit liushou loseland lfaminc_net familysize fage mage age expectedu i.year i.region, fe 
margins,dydx(loseland)

